/*
        file: main.h
          by: Johan Svensson <johan@ecsdg.lu.se>
    email to: <NA@ecsdg.lu.se>
        date: 1994-12-04
 last update: 1995-01-29
   copyright: Copyright (C) 1994-95 JoS-Ware Comp Tech, Sweden
       notes: Main header file for project NewsArchiver

#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#


*/


#define PRGNAME "NewsArchive"
#define NewsArchiveVERSION "1.0"
#define HELPURL "http://ecsdg.lu.se/NewsArchive/about.html"
#define ARTFILE "articles.id"
#define MAXART 100


/* Found-masks */
#define F_NNTPSERVER      1
#define F_NNTPPORT        2
#define F_GROUPNAME       4
#define F_GROUPROOT       8

/* Run Mode Flags */
#define RMF_LISTGROUPS    1
#define RMF_GROUP         2
#define RMF_ARTICLE       4


/* STRINGS */
#define S_CONTENT       "Content-Type: text/html"
#define S_CONTENT_TYPE  "Content-Type"
#define S_TEXT_HTML     "text/html"

#define S_AMPERSAND     "&amp;"
#define S_LESSTHAN      "&lt;"
#define S_GREATERTHAN   "&gt;"

#define N_WRONGUSAGE	"100"
#define S_WRONGUSAGE	"Wrong Usage!"

#define N_NOCONFFILE	"101"
#define S_NOCONFFILE	"You must supply a configuration file as the first argument."

#define N_CANTOPENCONFF	"102"
#define S_CANTOPENCONFF	"Cannot open configuration file"

#define N_CANTOPENMIDF	"103"
#define S_CANTOPENMIDF	"Cannot open Message-ID file"

#define N_CANTOPENARTF	"104"
#define S_CANTOPENARTF	"Cannot open article file"

#define N_NOCONNECT     "201"
#define S_NOCONNECT     "NNTP-server does not hear me"

#define N_NOGROUP       "202"
#define S_NOGROUP       "Unable to retrieve group"

#define N_NOART         "203"
#define S_NOART         "Article does not exist"

#define N_NO423         "204"
#define S_NO423         "Server does not return 423 as it should"

#define N_NOARTBODY     "205"
#define S_NOARTBODY     "Cannot get body of article"

#define N_EXIT		"999"
#define S_EXIT		"Exiting"

/* externals from nntp.c: */
extern SWORD  socket_connect   (char *machine);
extern SWORD  put_server       (char *string);
extern SWORD  get_server       (char *string, SDWORD size);
extern void   close_server     (void);
extern SWORD  connect_server   (char *machine);
extern SWORD  reconnect_server (char *machine);
extern SWORD  nntp_connect     (char *machine);
extern void   getauthorlist    (char *machine, char *subjects[], SDWORD first, 
                                SDWORD last, SDWORD row);

/* externals from str.c: */
extern char *strnset         (char *s, int ch, size_t n);
extern char *strupr          (char *str);
extern char *strunhtml       (char *str);
extern char *slash2dash      (char *str);


/* internal functions from main.c: */
UWORD readconffile(UWORD, char**);
UWORD artexists(char *thisfile);
UWORD getgroup(char *name,UDWORD *min,UDWORD *max);
UDWORD getarticle(char *name,UDWORD minid,UDWORD maxid);
void showtimedata(void);

