/*
        file: str.c
          by: Johan Svensson <johan@ecsdg.lu.se>
    email to: <NA@ecsdg.lu.se>
        date: 1994-08-02
 last update: 1995-01-29
   copyright: Copyright (C) 1994-95 JoS-Ware Comp Tech, Sweden
       notes: 

#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

*/

#include "generic.h"

#ifndef strnset
char *strnset(char *s, int ch, size_t n) {
   UWORD count;

   for (count = 0; count < n; count++)
      s[count] = ch;
   return s;
 }

#endif

#ifndef strupr
char *strupr(char *str) {
  int length, i;

  length = strlen(str);
  for (i=0; i<length; i++)
    str[i] = toupper(str[i]);

  return str;
}
#endif

/* This is old stuff:
char *strunhtml(char *str) {
   int length, i;
   char *tempstr;
   char tstr[2];
   
   length = strlen(str);
   tempstr = (char *) malloc(length * 5);
   strnset(tempstr, '\0', strlen(tempstr));
   for (i = 0; i < length; i++) {
      if (str[i] == '<') {
         strcat(tempstr, "&lt;");
      }
      else if (str[i] == '>') {
         strcat(tempstr, "&gt;");
      }
      else if (str[i] == '&') {
         strcat(tempstr, "&amp;");
      }
      else {
         sprintf(tstr, "%c", str[i]);
         strcat(tempstr, tstr);
      }
   }
   return tempstr;
}
*/

char *strunhtml(char *str) {
   int l, i, j;
   char *t;

   j = 0;
   l = strlen(str);
   t = (char *) malloc(l * 5);
   for (i = 0; i < l; i++) {
      if (str[i] == '<') {
         t[j++] = '&';
         t[j++] = 'l';
         t[j++] = 't';
         t[j++] = ';';
      }
      else if (str[i] == '>') {
         t[j++] = '&';
         t[j++] = 'g';
         t[j++] = 't';
         t[j++] = ';';
      }
      else if (str[i] == '&') {
         t[j++] = '&';
         t[j++] = 'a';
         t[j++] = 'm';
         t[j++] = 'p';
         t[j++] = ';';
      }
      else {
         t[j++] = str[i];
      }
   }
   t[j] = '\0';
   return t;
}


char *slash2dash(char *str) {
   int l, i, j;
   char *t;

   j = 0;
   l = strlen(str);
   t = (char *) malloc(l);
   for (i = 0; i < l; i++) {
      if (str[i] == '/')
         t[j++] = '-';
      else
         t[j++] = str[i];
   }
   t[j] = '\0';
   return t;
}
